DECLARE FUNCTION GetR! (ColorRef AS LONG)
DECLARE FUNCTION GetG! (ColorRef AS LONG)
DECLARE FUNCTION GetB! (ColorRef AS LONG)
DECLARE FUNCTION GetMostSimilarIndex! (ColorRef AS LONG, StandardPal() AS LONG)

'Bmpļͷṹ
TYPE BmpHead
    Head AS STRING * 2
    FileLength AS LONG
    Junk AS LONG
    PicBegin AS LONG
END TYPE

'BmpļϢ鶨
TYPE BmpBody
    Length AS LONG
    Width AS LONG
    Height AS LONG
    Plane AS INTEGER
    Bits AS INTEGER
    Junk AS LONG
    PicLength AS LONG
    PixelPerMeterX AS LONG
    PixelPerMeterY AS LONG
    ZeroFill AS STRING * 8
END TYPE

ON ERROR RESUME NEXT

'ûļļǷ
IF COMMAND$ = "" THEN
    INPUT "Please enter the filename: ", filename$
ELSE
    filename$ = COMMAND$
END IF

'ֲļǷڵķЩ벻õİ취

'ļ
OPEN filename$ FOR INPUT AS #1
'Ϊ53Ҳļ
WHILE ERR = 53
    PRINT "Can't open file!!!"
    INPUT "Please enter the filename: ", filename$
    'ŸΪ2
    ERROR 2
    OPEN filename$ FOR INPUT AS #1
WEND

'ļ
CLOSE #1
OPEN filename$ FOR BINARY AS #1

DIM myHead AS BmpHead
DIM myBody AS BmpBody
DIM PicturePal(16) AS LONG
DIM StandardPal(16) AS LONG
DIM myPalette(16) AS INTEGER
DIM ByteStream AS STRING * 1

'ϵͳ׼ɫ
StandardPal(0) = 0
StandardPal(1) = 128
StandardPal(2) = 32768
StandardPal(3) = 32896
StandardPal(4) = 8388608
StandardPal(5) = 8388736
StandardPal(6) = 8421376
StandardPal(7) = 12632256
StandardPal(8) = 8421504
StandardPal(9) = 255
StandardPal(10) = 65280
StandardPal(11) = 65535
StandardPal(12) = 16711680
StandardPal(13) = 16711935
StandardPal(14) = 16776960
StandardPal(15) = 16777215

'ļͷֽǷΪBM
GET #1, 1, myHead
IF myHead.Head <> "BM" THEN
    PRINT "Not Bmp image!!!"
    END
END IF

'ļǷΪ16ɫͼ
GET #1, 15, myBody
IF myBody.Bits <> 4 THEN
    PRINT "Not 16-color image!!!"
    END
END IF

'ƥɫ
FOR i% = 0 TO 15
    GET #1, LOC(1) + 1, PicturePal(i%)
    myPalette(i%) = GetMostSimilarIndex(PicturePal(i%), StandardPal())
NEXT i%

SCREEN 12

'ʾͼ
FOR y% = myBody.Height - 1 TO 0 STEP -1
    FOR x% = 0 TO myBody.Width - 1 STEP 2
        GET #1, LOC(1) + 1, ByteStream

        High% = ASC(ByteStream)
        Low% = High% MOD 16
        High% = High% \ 16

        PSET (x%, y%), myPalette(High%)
        IF x% + 1 < myBody.Width THEN PSET (x% + 1, y%), myPalette(Low%)
    NEXT x%

    'BmpͼҪÿݿ鳤Ϊ4ı˷һЩݴ
    'дʱҪųЧ
    IF INT(myBody.Width / 2 + .5) MOD 4 <> 0 THEN
        SEEK #1, LOC(1) + 5 - INT(myBody.Width / 2 + .5) MOD 4
    END IF
NEXT y%

CLOSE #1

'
none$ = INPUT$(1)
SCREEN 0

END

FUNCTION GetB (ColorRef AS LONG)
    GetB = ColorRef \ 65536
END FUNCTION

FUNCTION GetG (ColorRef AS LONG)
    GetG = (ColorRef AND 65280) / 256
END FUNCTION

FUNCTION GetMostSimilarIndex (ColorRef AS LONG, StandardPal() AS LONG)
    Compare& = 102400
    min% = 0

    FOR i% = 0 TO UBOUND(StandardPal)
        sum& = ABS(GetR(ColorRef) - GetR(StandardPal(i%))) * 33
        sum& = sum& + ABS(GetG(ColorRef) - GetG(StandardPal(i%))) * 55
        sum& = sum& + ABS(GetB(ColorRef) - GetB(StandardPal(i%))) * 12

        IF Compare& > sum& THEN
            min% = i%
            Compare& = sum&
        END IF
    NEXT i%

    GetMostSimilarIndex = min%
END FUNCTION

FUNCTION GetR (ColorRef AS LONG)
    GetR = ColorRef AND 255
END FUNCTION

